"use strict";
'use client';
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownBreaker = exports.DropdownLink = exports.Dropdown = void 0;
var tslib_1 = require("tslib");
var jsx_runtime_1 = require("react/jsx-runtime");
var link_1 = tslib_1.__importDefault(require("next/link"));
var react_1 = require("react");
var bs_1 = require("react-icons/bs");
function Dropdown(_a) {
    var children = _a.children, label = _a.label, _b = _a.openTimeout, openTimeout = _b === void 0 ? 150 : _b;
    var _c = (0, react_1.useState)(false), isOpen = _c[0], setIsOpen = _c[1];
    var _d = (0, react_1.useState)(null), hoverTimer = _d[0], setHoverTimer = _d[1];
    var onMouseEnter = function () {
        // Clear any existing timer when mouse enters the dropdown area again
        if (hoverTimer) {
            clearTimeout(hoverTimer);
            setHoverTimer(null);
        }
        setIsOpen(true);
    };
    var onMouseLeave = function () {
        // Set a timer to close the dropdown after 300ms
        var timer = setTimeout(function () {
            setIsOpen(false);
        }, openTimeout);
        setHoverTimer(timer);
    };
    (0, react_1.useEffect)(function () {
        // Clear the timer when the component is unmounted
        return function () {
            if (hoverTimer) {
                clearTimeout(hoverTimer);
            }
        };
    }, [hoverTimer]);
    return ((0, jsx_runtime_1.jsxs)("div", tslib_1.__assign({ className: 'relative inline-block', onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, { children: [(0, jsx_runtime_1.jsxs)("button", tslib_1.__assign({ className: "font-secondary text-lg flex items-center gap-2 ".concat(isOpen ? 'text-zinc-100 ' : 'text-zinc-400'), onClick: function () { return setIsOpen(!isOpen); } }, { children: [label, ' ', (0, jsx_runtime_1.jsx)(bs_1.BsTriangleFill, { className: "inline-block text-xs transition-all ".concat(isOpen ? 'rotate-180' : 'rotate-0') })] })), (0, jsx_runtime_1.jsx)("div", tslib_1.__assign({ className: "".concat(isOpen ? 'block' : 'hidden', " absolute mt-2 w-fit rounded-md shadow-lg p-4 right-0 bg-zinc-800 transition ease-out duration-200 flex flex-col gap-2 z-50"), role: 'menu' }, { children: children }))] })));
}
exports.Dropdown = Dropdown;
function DropdownLink(_a) {
    var label = _a.label, href = _a.href, className = _a.className, children = _a.children;
    return ((0, jsx_runtime_1.jsxs)(link_1.default, tslib_1.__assign({ href: href, className: 'flex flex-row gap-2 items-center' }, { children: [label && (0, jsx_runtime_1.jsx)("span", tslib_1.__assign({ className: "text-base text-zinc-400 hover:text-purple-500 ".concat(className) }, { children: label })), children] })));
}
exports.DropdownLink = DropdownLink;
function DropdownBreaker() {
    return (0, jsx_runtime_1.jsx)("hr", { className: 'border-zinc-700 border-2 my-2' });
}
exports.DropdownBreaker = DropdownBreaker;
//# sourceMappingURL=index.js.map